<?php
/**
 * ----------------------------------------------------------
 * Copyright (c) 2005  KLIK! Klein Informatik  
 *                     www.klik-info.ch rklein@klik-info.ch
 * ----------------------------------------------------------
 *
 * KLIK! Mini-Shop
 *
 * Dieses Skript darf nicht in Projekten verwendet werden, die
 * faschistisches, rassistisches, sexistisches oder 
 * fanatisch-religioeses Gedankengut propagieren.
 *
 * @author      Roger Klein
 * @copyright   Frei einsetzbar, solange obige Vorgabe erfuellt ist
 *              und alle (c) Kommentar-Zeilen im Code bleiben
 * @version     1.0 | 2005-10-12
 */
 
class WarenKorb 
{

    var $mArrArtikel = array();

    function nimmArtikelDazu($artikelId, $anz = 0, $preis = 0) 
    {
        if (isset($this->mArrArtikel[$artikelId]))
        {
            $this->mArrArtikel[$artikelId]['anz'] += abs(intval($anz));
        }
        else
        {
            $this->mArrArtikel[$artikelId]['anz'] = abs(intval($anz));
        }
        $this->mArrArtikel[$artikelId]['preis'] = $preis;
    }

    function entferneArtikel($artikelId) 
    {
        if (!isset($this->mArrArtikel[$artikelId]))
        {
            return false;
        }
        else
        {
            unset($this->mArrArtikel[$artikelId]);
        }
        return true;
    }

    function entleereWarenkorb() 
    {
        foreach (array_keys($this->mArrArtikel) as $artikel_id)
        {
            unset($this->mArrArtikel[$artikel_id]);
        }
    }
    
    function aendereAnzahlArtikel($artikelId, $anz = 0) {
        if (!isset($this->mArrArtikel[$artikelId]))
        {
            return false;
        }
        else if (abs(intval($anz)) != 0)
        {
            $this->mArrArtikel[$artikelId]['anz'] = abs(intval($anz));
        }
        return true;
    }
    

    function zeigeWarenkorb()
    {
        $korbinhalt = '';
        reset($this->mArrArtikel);
        foreach ($this->mArrArtikel as $artikel_id => $artikel)
        {
            if ($artikel['anz'] > 0)
            {
                $korbinhalt .=  sprintf('%d x %s &agrave; %01.2f<br />',
                                        $artikel['anz'], 
                                        $artikel_id, 
                                        $artikel['preis']);
            }
        }
        return $korbinhalt;
    }
      
    function status() 
    {
        reset($this->mArrArtikel);
        $anz_artikel = 0;
        $summe       = 0;
        foreach ($this->mArrArtikel as $artikel)
        {
            if ($artikel['anz'] > 0)
            {
                $anz_artikel += $artikel['anz'];
                $summe += $artikel['anz'] * $artikel['preis'];
            }
        }
        return array($anz_artikel, $summe);
    }

    function testeEingaben() 
    {
        $error            = 0;
        $anzahl_parameter = func_num_args();
        for ($i = 0; $i < $anzahl_parameter; $i++)
        {
            $wert = func_get_arg($i);
            if ($wert != '' && !ereg('^[0-9]{1,3}$', $wert)) 
            {
                $error = -($i+1);
            }
        }
        return $error;
    }

}
?>
